import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';

// Impoart the data form github
const csvUrl = 'https://gist.githubusercontent.com/Sheshidharreddy/ef507a6ea2aba4e67876aaa27ae40041/raw/a819d4910aee49466d907d4950c1b4dc8a7f3ac9/irish.csv';  

// This is the function which store data in each variable
const parseRow = (d) => {
  d.sepal_length = +d.sepal_length;
  d.sepal_width = +d.sepal_width;
  d.petal_length = +d.petal_length;
  d.petal_width = +d.petal_width;
  return d;
};
// Here we assign the window width and height
const width = window.innerWidth;
const height = window.innerHeight;

// Appends the SVG into the body of HTML
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const main = async () => {
  
  // Here created new Scatter Plot object
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.petal_width)
    .yValue((d) => d.sepal_length)
  
    .margin({
      top: 20,
      right: 20,
      bottom: 40,
      left: 50,
    })
    .radius(5);

  // Plotting the Scatter Plot axes based on the given parameters
  svg.call(plot);

  const columns = [
    'petal_width',
    'sepal_width',
    'petal_length',
    'sepal_length',
  ];
  
  // Plotting the data on the Scatter Plot
  let i = 0;
 	setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);
    svg.call(plot);
    i++;
  }, 2000);
};
main();



